<?php

/**
 * @file
 * Base class for the features Menu UUID module's tests.
 */

/**
 * Base class for the features Menu UUID module's tests.
 */
class FeaturesMenuUuidBaseTestCase extends DrupalWebTestCase {

  /**
   * Use the standard install profile, to give lots of menu items.
   *
   * @var string
   */
  protected $profile = 'standard';

  /**
   * Set up test.
   */
  public function setUp(array $modules = array()) {
    $modules[] = 'features_menu_uuid';
    parent::setUp($modules);

    // Run a features rebuild to ensure our feature is fully installed.
    features_rebuild();

    // Skip concerns with permissions, just log in as user 1.
    $this->loginUser1();
  }

  /**
   * Log in as user 1.
   */
  protected function loginUser1() {
    $password = user_password();

    // Reset the user 1 password.
    $account = user_load(1);
    $edit = array(
      'pass' => $password,
    );
    $account = user_save($account, $edit);
    $account->pass_raw = $password;

    // Log in as user 1.
    $this->drupalLogin($account);
  }

  /**
   * {@inheritdoc}
   */
  protected function verbose($message, $title = NULL) {
    // Handle arrays, objects, etc.
    if (!is_string($message)) {
      $message = "<pre>\n" . print_r($message, TRUE) . "\n</pre>\n";
    }

    // Optional title to go before the output.
    if (!empty($title)) {
      $title = '<h2>' . check_plain($title) . "</h2>\n";
    }

    parent::verbose($title . $message);
  }

  /**
   * Provide a list of menu items.
   *
   * @param int $count
   *   The number of menu items to return.
   *
   * @return array
   *   A list of menu item UUIDs.
   */
  protected function someMenuItems($count = 5) {
    $all_items = menu_links_uuid_features_export_options();
    $some_items = array_slice($all_items, 0, $count);
    $this->verbose($some_items);
    $selected_items = array();
    foreach (array_keys($some_items) as $item) {
      $selected_items[$item] = $item;
    }
    $this->verbose($selected_items);

    return $selected_items;
  }

}
